unit KCompilerEx;

interface
uses
  KCompiler;

type
  TKCompilerEx = class(TKCompiler)
    procedure Compile; override;
  end;
  ECompError = class(Exception);


var
  Msgs : array [TError] of string =
  ('Compiled successfully',
   'Error occured during constant calculation',
   'Invalid numeric format',
   'Value expected',
   'Operation expected',
   ''')'' expected',
   'Unknown identifier',
   'Constant is out of range',
   'Incompatible types',
   'Types of formal and actual var parameters must be identical',
   'Number of parameters doesn''t match function prototype');

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('DOMIN', [TKCompilerEx]);
end;

{ TKCompilerEx }

procedure TKCompilerEx.Compile;
begin
  inherited;
  if CompError <> eNone then
    raise ECompError.Create(Msgs[CompError]);
end;

end.
 