unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  KCompiler, ExtCtrls, StdCtrls, KLib;

type
  TMainForm = class(TForm)
    RadioGroup : TRadioGroup;
    Image : TImage;
    KCompiler1 : TKCompiler;
    procedure RadioGroupClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    CenterX, CenterY : Integer;
    function  GetPoint(X, Y, Z: Extended) : TPoint;
    procedure DrawGraph;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  x, y : Extended;
const
  Ratio = 40;
  Sections = 100;
  Range = 2;


implementation

{$R *.DFM}

procedure TMainForm.RadioGroupClick(Sender: TObject);
begin
  KCompiler1.ExprString := RadioGroup.Items[RadioGroup.ItemIndex];
  DrawGraph;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  CenterX := Image.Width div 2;
  CenterY := Image.Height div 2;
  KCompiler1.RegisterVarExt('x', vtExtended, @X);
  KCompiler1.RegisterVarExt('y', vtExtended, @Y);
  RegisterMin(KCompiler1, 'min');
  RegisterMax(KCompiler1, 'max');
  RegisterSin(KCompiler1, 'sin');
  RegisterCos(KCompiler1, 'cos');
  RegisterExp(KCompiler1, 'exp');
  RegisterSqr(KCompiler1, 'sqr');
  RegisterSqrt(KCompiler1, 'sqrt');
  RegisterLn(KCompiler1, 'ln');
  RegisterAbs(KCompiler1, 'abs');
  DrawGraph;
end;

procedure TMainForm.DrawGraph;
var
  i : Integer;
  Pt : TPoint;
  delta : Extended;
  Max, Min : Array [0..1999] of Integer;
begin
  with Image.Canvas do begin
    Brush.Color := clBlack;
    FillRect(Rect(0, 0, Width, Height));
    if RadioGroup.ItemIndex = -1 then Exit;
    for i := 0 to 1999 do
    begin
      Max[i] := 0;
      Min[i] := Height;
    end;
    x := Range;
    delta := 2 * Range / Sections;
    while x >= -Range do begin
      y := -Range;
      while y <= Range do begin
        Pt := GetPoint(x, y, KCompiler1.Evaluate);
        if Pt.y < Min[Pt.x] then begin
          Pixels[Pt.x, Pt.y] := clLime;
          Min[Pt.x] := Pt.y;
        end;
        if Pt.y > Max[Pt.x] then begin
          Pixels[Pt.x, Pt.y] := clLime;
          Max[Pt.x] := Pt.y;
        end;
        y := y + delta;
      end;
      x := x - delta;
    end;
  end;
end;

function TMainForm.GetPoint(x, y, z: Extended) : TPoint;
begin
  Result := Point(Round(CenterX + Ratio * (x - y * 1/sqrt(2))), Round(CenterY + Ratio * (-z + y * 1/sqrt(2))));
end;

end.
