unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, KLib,
  StdCtrls, KCompiler, ExtCtrls;

type
  TMainForm = class(TForm)
    KCompiler: TKCompiler;              
    FuncBox: TGroupBox;
    ExprText: TEdit;          
    Button1: TButton;
    ResultText: TEdit;
    VarBox: TGroupBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure FuncChckClick(Sender : TObject);
    procedure VarChckClick(Sender : TObject);
    procedure VarEditExit(Sender : TObject);
  public
    { Public declarations }
  end;
  TFunc = function(AKCompiler : TKCompiler; alias : string) : boolean;

var
  MainForm: TMainForm;
  Funcs : array [0..37] of TFunc;
  FuncChcks : array [0..37] of TCheckBox;
  Names : array [0..37] of string =
  ('sin', 'cos', 'tan', 'cotan', 'arcsin', 'arccos', 'arctan', 'arccotan',
   'sinh', 'cosh', 'tanh', 'cotanh', 'arcsinh', 'arccosh', 'arctanh',
   'arccotanh', 'min', 'max', 'IntPower', 'Power', 'abs', 'sqrt', 'sqr', 'exp',
   'int', 'frac', 'round', 'ln', 'log2', 'log10', 'logn', 'one', 'l2t', 'l2e',
   'pi', 'lg2', 'ln2', 'zero');
  Msgs : array [TError] of string =
  ('Compiled succesfully!',
   'Constant value cannot be represented in current format!',
   'Invalid numeric format!',
   'Value expected!',
   'Operation expected!',
   ''')'' expected!',
   'Uknown indefitier!',
   'Constant is out of range!',
   'Incompatible types!',
   'Types of formal and actual var parameters must be identical!',
   'Number of parameters doesn''t match function prototype!');
   vars : array [0..3] of extended;
   VarChcks : array [0..3] of TCheckBox;
   VarEdits : array [0..3] of TEdit;

implementation

{$R *.DFM}

procedure TMainForm.FuncChckClick(Sender: TObject);
var
  i : Integer;
begin
  i := (Sender as TCheckBox).Tag;
  if FuncChcks[i].Checked then begin
    if not Funcs[i](KCompiler, Names[i]) then begin
      MessageBox(0, PChar('Couldn''t register ' + Names[i] + ' function'), 'Registration error', MB_OK);
      FuncChcks[i].Checked := false;
    end;
  end
  else KCompiler.RemoveFunc(KCompiler.FuncCode(Names[i]));
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  Funcs[0] := RegisterSin;
  Funcs[1] := RegisterCos;
  Funcs[2] := RegisterTan;
  Funcs[3] := RegisterCotan;
  Funcs[4] := RegisterArcSin;
  Funcs[5] := RegisterArcCos;
  Funcs[6] := RegisterArcTan;
  Funcs[7] := RegisterArcCotan;
  Funcs[8] := RegisterCosh;
  Funcs[9] := RegisterSinh;
  Funcs[10] := RegisterTanh;
  Funcs[11] := RegisterCotanh;
  Funcs[12] := RegisterArcCosh;
  Funcs[13] := RegisterArcSinh;
  Funcs[14] := RegisterArcTanh;
  Funcs[15] := RegisterArcCotanh;
  Funcs[16] := RegisterMin;
  Funcs[17] := RegisterMax;
  Funcs[18] := RegisterIntPower;
  Funcs[19] := RegisterPower;
  Funcs[20] := RegisterAbs;
  Funcs[21] := RegisterSqrt;
  Funcs[22] := RegisterSqr;
  Funcs[23] := RegisterExp;
  Funcs[24] := RegisterInt;
  Funcs[25] := RegisterFrac;
  Funcs[26] := RegisterRound;
  Funcs[27] := RegisterLn;
  Funcs[28] := RegisterLog2;
  Funcs[29] := RegisterLog10;
  Funcs[30] := RegisterLogN;
  Funcs[31] := RegisterOne;
  Funcs[32] := RegisterL2T;
  Funcs[33] := RegisterL2E;
  Funcs[34] := RegisterPi;
  Funcs[35] := RegisterLg2;
  Funcs[36] := RegisterLn2;
  Funcs[37] := RegisterZero;
  for i := 0 to 37 do begin
    FuncChcks[i] := TCheckBox.Create(FuncBox);
    FuncChcks[i].Parent := FuncBox;
    FuncChcks[i].Caption := Names[i];
    FuncChcks[i].Left := 10 + i div 10 * 70;
    FuncChcks[i].Top := 20 + i mod 10 * 18;
    FuncChcks[i].OnClick := FuncChckClick;
    FuncChcks[i].Tag := i;
  end;
  for i := 0 to 3 do begin
    VarChcks[i] := TCheckBox.Create(VarBox);
    VarChcks[i].Parent := VarBox;
    VarChcks[i].Caption := char(ord('A') + i) + ' = ';
    VarChcks[i].Left := 22 + i div 2 * 150;
    VarChcks[i].Top := 22 + i mod 2 * 25;
    VarChcks[i].OnClick := VarChckClick;
    VarChcks[i].Tag := i;
    VarEdits[i] := TEdit.Create(VarBox);
    VarEdits[i].Parent := VarBox;
    VarEdits[i].Width := 80;
    VarEdits[i].Left := 67 + i div 2 * 150;
    VarEdits[i].Top := 20 + i mod 2 * 25;
    VarEdits[i].Tag := i;
    VarEdits[i].Text := FloatToStr(vars[i]);
    VarEdits[i].Enabled := false;
    VarEdits[i].OnExit := VarEditExit;
  end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  KCompiler.ExprString := ExprText.Text;
  if KCompiler.CompError = eNone then
    ResultText.Text := FloatToStr(KCompiler.Evaluate)
  else
    ResultText.Text := Msgs[KCompiler.CompError];
end;

procedure TMainForm.VarChckClick(Sender: TObject);
var
  i : Integer;
begin
  i := (Sender as TCheckBox).Tag;
  if VarChcks[i].Checked then begin
    if KCompiler.RegisterVarExt(char(ord('a')+i), vtExtended, @vars[i]) = 0 then begin
      MessageBox(0, PChar('Couldn''t register ' + char(ord('A')+i) + ' variable'), 'Registration error', MB_OK);
      VarChcks[i].Checked := false;
    end
    else VarEdits[i].Enabled := true;
  end
  else begin
    KCompiler.RemoveVar(KCompiler.VarCode(char(ord('a') + i)));
    VarEdits[i].Enabled := false;
  end;
end;

procedure TMainForm.VarEditExit(Sender: TObject);
var
  i : Integer;
  a : extended;
begin
  i := (Sender as TEdit).Tag;
  try
    a := StrToFloat(VarEdits[i].Text);
  except
    on EConvertError do a := vars[i];
  end;
  vars[i] := a;
  VarEdits[i].Text := FloatToStr(vars[i]);
end;

end.
